feat_s Struct Reference

## Data Fields

int | refcount
| Reference count. More...
char * | name
| Printable name for this feature type.
int32 | cepsize
| Size of input speech vector (typically, a cepstrum vector)
int32 | n_stream
| Number of feature streams; e.g., 4 in Sphinx-II.
uint32 * | stream_len
| Vector length of each feature stream.
int32 | window_size
| Number of extra frames around given input frame needed to compute corresponding output feature (so total = window_size*2 + 1)
int32 | n_sv
| Number of subvectors.
uint32 * | sv_len
| Vector length of each subvector.
int32 ** | subvecs
| Subvector specification (or NULL for none)
mfcc_t * | sv_buf
| Temporary copy buffer for subvector projection.
int32 | sv_dim
| Total dimensionality of subvector (length of sv_buf)
cmn_type_t | cmn
| Type of CMN to be performed on each utterance.
int32 | varnorm
| Whether variance normalization is to be performed on each utt; Irrelevant if no CMN is performed.
agc_type_t | agc
| Type of AGC to be performed on each utterance.
void(* | compute_feat )(struct feat_s *fcb, mfcc_t **input, mfcc_t **feat)
| Feature computation function. More...
cmn_t * | cmn_struct
| Structure that stores the temporary variables for cepstral means normalization.
agc_t * | agc_struct
| Structure that stores the temporary variables for acoustic gain control.
mfcc_t ** | cepbuf
| Circular buffer of MFCC frames for live feature computation. More...
mfcc_t ** | tmpcepbuf
| Array of pointers into cepbuf to handle border cases. More...
int32 | bufpos
| Write index in cepbuf. More...
int32 | curpos
| Read index in cepbuf. More...
mfcc_t *** | lda
| Array of linear transformations (for LDA, MLLT, or whatever)
uint32 | n_lda
| Number of linear transformations in lda. More...
uint32 | out_dim
| Output dimensionality.

## Detailed Description

Definition at line 155 of file feat.h.

## Field Documentation

int32 feat_s::bufpos

Write index in cepbuf.

Definition at line 194 of file feat.h.

mfcc_t** feat_s::cepbuf

Circular buffer of MFCC frames for live feature computation.

Definition at line 192 of file feat.h.

void(* feat_s::compute_feat)(struct feat_s *fcb, mfcc_t **input, mfcc_t **feat)

Feature computation function.

Parameters

  fcb | the feat_t describing this feature type
  input | pointer into the input cepstra
  feat | a 2-d array of output features (n_stream x stream_len)

Returns
  0 if successful, -ve otherwise.

Function for converting window of input speech vector (input[-window_size..window_size]) to output feature vector (feat[stream][]). If NULL, no conversion available, the speech input must be feature vector itself.

Definition at line 186 of file feat.h.

int32 feat_s::curpos

Read index in cepbuf.

Definition at line 195 of file feat.h.

uint32 feat_s::n_lda

Number of linear transformations in lda.

Definition at line 198 of file feat.h.

int feat_s::refcount

Reference count.

Definition at line 156 of file feat.h.

mfcc_t** feat_s::tmpcepbuf

Array of pointers into cepbuf to handle border cases.

Definition at line 193 of file feat.h.

The documentation for this struct was generated from the following file:

- include/sphinxbase/feat.h